/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of CArray.xs. Do not edit this file, edit CArray.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "CArray.xs"
/* -*- Mode: C -*- */
/* A tied ARRAY should have those methods:
    TIEARRAY classname, LIST               | ->new
    FETCH this, key                        | ->get
    STORE this, key, value                 | ->set
    FETCHSIZE this                         | ->len
    STORESIZE this, count                  | ->grow
    DESTROY this                           | ->DESTROY
  new with perl 5.6:
    CLEAR this                             | ->
    PUSH this, LIST                        | ->
    POP this                               | ->
    SHIFT this                             | ->
    UNSHIFT this, LIST                     | ->
    SPLICE this, offset, length, LIST      | ->splice
    EXTEND this, count                     | ->grow
  Todo:
   lvalue splice (not as hard as it seems to be)
   SCALAR @array                           | ->len
   SCALAR $#array                          | ->len -1
*/

#ifdef __cplusplus
extern "C" {
#endif

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* #include <string.h> */
#include <float.h>

#ifdef __cplusplus
}
#endif

#define RCS_STRING "$Id: CArray.xs 0.15 2000/01/11 07:39:44 rurban Exp $"
#define OLD /* with OLD don't use the new version yet, stay 0.11 compatible */

/* We need some memory optimization values here */
#define PAGEBITS  11                    /* we can also use 10 or 12, most system malloc to 12 ie 4096 */
#define MY_PAGESIZE  (1 << PAGEBITS)    /* 2048 byte is the size of a fresh carray */

char *g_classname;                      /* global classname for a typemap trick    */
                                        /* to return the correct derived class     */

/* for linux Dynaloader */
#ifndef max
#define max(aaa,bbb) ((aaa) < (bbb) ? (bbb) : (aaa))
#define min(aaa,bbb) ((aaa) < (bbb) ? (aaa) : (bbb))
#endif

#define MAXITEMSIZE max(sizeof(double3),sizeof(int4))

/* #define MYDEBUG_FREE */

#ifdef DEBUGGING
#define DBG_PRINTF(X) printf X
#else
#define DBG_PRINTF(X)
#endif

/* perl-64 compliant version */
#if defined(USE_64_BITS) && defined(HAS_QUAD)
  #if defined(_MSC_VER) && !defined(Quad_T)  /* temp msvc fix */
    #define Quad_T	__int64
    #define Uquad_T 	unsigned __int64
  #endif
#endif

/* The base and the specialized classes for type checks on args. */
/* CIntArray is derived from CArray, you just cannot do pointer
   arithmetic with void *CArray->ptr. */
#ifdef OLD
typedef struct {
    int 	  len;
    void 	  * ptr;
    int 	  freelen;
    size_t	  elsize;		/* ie itemsize */
} Tie__CArray;
typedef struct {
    int 	  len;
    IV 		  * ptr;
    int 	  freelen;
    size_t	  elsize;		/* ie itemsize */
} Tie__CIntArray;
typedef struct {
    int 	  len;
    NV	 	  * ptr;
    int 	  freelen;
    size_t	  elsize;		/* ie itemsize */
} Tie__CDoubleArray;
typedef struct {
    int 	  len;
    char 	**ptr;
    int 	  freelen;
    size_t	  elsize;		/* ie itemsize */
} Tie__CStringArray;
#endif
                                        /* Geometric interpretation: */
typedef IVTYPE int2[2];                 /* edge pairs                */
typedef IVTYPE int3[3];                 /* triangle indices          */
typedef IVTYPE int4[4];                 /* tetras or quads           */
typedef NVTYPE double2[2];              /* point2d                   */
typedef NVTYPE double3[3];              /* point3d                   */

#ifndef OLD
/* ***************************************************************** */
/* Arbitrary structures borrowed from Tie::MmapArray
 */
/* Descriptor structures for the main mmap'ed array and sub-array or
 * sub-hash fields.  The sub-fields are described by an array of these
 * fields pointed to in the parent structure.
 *
 * Note that the first five fields are identical in all three
 * structures, so they can be used interchangably when dealing with an
 * arbitraty element.  The fifth field (offset) is not actually used
 * in the top-level structure (by definition it will always be zero).
 */

#define ARRAY_FIELDS        '['
#define HASH_FIELDS         '{'
#define DEFAULT_TYPE	    'i'
#define DEFAULT_TYPE_SIZE   sizeof(IV)

typedef struct {
    int 	  len;
    void 	  * ptr;
    int 	  freelen;
   /* new with 0.12: */
    size_t	  elsize;		/* ie itemsize */
    char	  eltype;               /* pack char or array or hash */

    int		  offset;	  	/* for displaced arrays */
    unsigned int  readonly : 1;
    int		  refcnt;
} Tie__CArray;                          /* help typemap */


typedef struct {
    int 	  len;
    void 	  * ptr;
    int 	  freelen;

    size_t	  elsize;
    char	  eltype;
    int		  offset;	  	/* for displaced arrays */
    unsigned int  readonly : 1;
    int		  refcnt;
}
ARRAY_ELEMENT_T;

typedef struct {
    int 	  len;
    void 	  * ptr;
    int 	  freelen;

    char	  eltype;
    size_t	  elsize;
    int		  offset;

    char	  *key;
}
HASH_ELEMENT_T;

typedef ARRAY_ELEMENT_T  ELEMENT_T;

/* Descriptor structures for sub-array and sub-hash references, passed
 * back to perl when asked for $array[$n] in code like
 * $array[$n]->[$m] or $array[$n]->{$key} (or more nested structures).
 *
 * The descriptors are converted to a Perl reference and passed to the
 * FETCH/STORE/DELETE subroutines.  They contain sufficient
 * information to access both a sub-structure element and the main
 * array.  The descriptor structures are identical exept for
 * the type of the field pointer so they can be handled by common
 * functions.
 */

typedef struct subarray {
    Tie__CArray     *array;
    ARRAY_ELEMENT_T *fields;
    int		    nfields;
    int		    recno;
    int		    cur_index;
}
Tie__CArray__SubArray;

typedef struct {
    Tie__CArray     *array;
    HASH_ELEMENT_T  *fields;
    int		    nfields;
    int		    recno;
    int		    cur_index;
}
Tie__CArray__SubHash;


/* Subrecord structure (doesn't matter which variety as it will be
 * cast when used).
 */
typedef struct subarray  SUBRECORD_REFERENCE_T;
#endif /* OLD */

/* Allocate a new carray, len must be set explicitly */
#define NEW_CARRAY(VAR,STRUCT_TYPE,LEN,ITEMSIZE) \
    VAR  = (STRUCT_TYPE *) safemalloc(sizeof(STRUCT_TYPE)); \
    VAR->freelen = freesize (LEN,ITEMSIZE); \
    VAR->ptr = safemalloc((LEN + VAR->freelen) * ITEMSIZE); \
    VAR->len = LEN;

/* VAR must exist */
#define MAYBE_GROW_CARRAY(VAR,STRUCT_TYPE,LEN,ITEMSIZE) \
  if (VAR->len < LEN) \
    VAR = (STRUCT_TYPE *)grow((Tie__CArray *)VAR,LEN - VAR->len,ITEMSIZE);

/* This is the to-tune part:
 * The overall size should fit into a page or other malloc chunks.
 * Leave room for "some" more items, but align it to the page size.
 * Should small arrays (<100) be aligned at 2048 or smaller bounds?
 * 10 => 2048-10, 2000 => 2048-2000, 200.000 => 2048
 * len is the actual length of the array, size the itemsize in bytes.
 */
int freesize (int len, int size)
{
    len *= size;
    return max(MY_PAGESIZE-len, len - ((len >> PAGEBITS) << PAGEBITS)) / size;
}

#ifndef OLD
/* A second approach for many small arrays could be more fine tuning
 * with more boundaries (128, 256, 2048)
 *   < 128 grow to 128, < 256 grow to 256, else grow to 2048.
 */
const int PAGE_BOUNDARY[4]; // = (128, 256, 2048, INT_MAX);  /* must be exponents of 2 */
const int PAGE_BOUNDARY_N = sizeof(PAGE_BOUNDARY)/sizeof(int) - 1;

int parametrized_freesize (int len, int elsize)
{
    int i;
    int pagesize = PAGE_BOUNDARY[3];
    len *= elsize;
    for ( i=0; i < PAGE_BOUNDARY_N; i++) {
        if (len > PAGE_BOUNDARY[i]) {
  	    int pagesize = PAGE_BOUNDARY[i+1];
	    int pagebits = log2(pagesize);
	    pagesize = max( pagesize-len,
			    len - ((len >> pagebits) << pagebits)) / elsize;
	}
    }
    return pagesize;
}
#endif /* OLD */

Tie__CArray *grow (Tie__CArray *carray, int n, int itemsize)
{
    int len = carray->len;
    /* make room for n new elements */
    if (n > carray->freelen) {
        carray->freelen = freesize (len + n, itemsize);
        carray->ptr = (void *) saferealloc (carray->ptr, len + carray->freelen);
        carray->len += n;
    } else {
        carray->freelen -= n;
        carray->len += n;
    }
    return carray;
}

static int
not_here(char *s)
{
    croak("%s not implemented on this architecture", s);
    return -1;
}

static double
constant(char *name, int arg)
{
    errno = 0;
    switch (*name) {
    }
    errno = EINVAL;
    return 0;

not_there:
    errno = ENOENT;
    return 0;
}

char *CBaseNAME     = "Tie::CArray";
char *CSubArrayNAME = "Tie::CArray::SubArray";
char *CSubHashNAME  = "Tie::CArray::SubHash";

char *CIntNAME   = "Tie::CIntArray";
char *CDblNAME   = "Tie::CDoubleArray";
char *CStrNAME   = "Tie::CStringArray";
char *CInt2NAME  = "Tie::CInt2Array";
char *CInt3NAME  = "Tie::CInt3Array";
char *CInt4NAME  = "Tie::CInt4Array";
char *CDbl2NAME  = "Tie::CDouble2Array";
char *CDbl3NAME  = "Tie::CDouble3Array";

char* ErrMsg_index    = "index out of range";
char* ErrMsg_itemsize = "no itemsize for CArray element defined";
char* ErrMsg_type     = "arg is not of type %s";

#define CHECK_DERIVED_FROM(i,NAME) \
  if (!SvROK(ST(i)) || !sv_derived_from(ST(i),NAME)) \
    croak(ErrMsg_type,NAME)

/* size per item n bytes, get it dynamically from READONLY vars
 * initalized at BOOT. This way we can add derived classes in perl easily.
 * Todo: get/set itemsize in the object struct not as package var
 */
int mysv_itemsize (SV *arg)
{
  char varname[80];
  char *classname;
  HV *stash;
  SV * sv;

  if ( stash = SvSTASH(SvRV(arg)) )
  {
    classname = HvNAME(stash);
    strcpy (varname, classname);
    strcat (varname, "::itemsize");
    if (!(sv = perl_get_sv(varname, FALSE)))
      goto sizeerr;
    else
      return SvIV(sv);
  }
sizeerr:
  croak (ErrMsg_itemsize);
  return 0;
}

/* To overcome ->new and ::new problems:
 * The first regular new arg must be an IV (len).
 * This might fail on some obscure situations,
 * but walking up the optree checking for -> or :: invocation is
 * too hard for now.
 */
char * mysv_classname (SV *this)
{
    if ( SvROK(this)  ) {
        HV *stash = SvSTASH(SvRV(this));
        if ( stash ) {
            return HvNAME(stash);
        }
    } else if(  SvPOK(this) && !SvIOK(this) ) {
        return SvPVX(this);
    }
    return NULL;
}

/* create a sv var, with some flag bits set */
int mysv_ivcreate ( int value, char *name, int flag)
{
    SV* sv = perl_get_sv( name, TRUE );
    sv_setiv( sv, value );
    SvFLAGS(sv) |= flag;
    return 1;
}

/* Todo: remove this */
int myarray_init (char *classname, Tie__CArray *carray, AV *av)
{
    int avlen, i, len;
    AV *av1;

    len = carray->len;
    avlen = av_len(av);
    /* initializing section: */
    if (strEQ(classname,CIntNAME)) {
        IV* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
            array[i] = SvIV(AvARRAY(av)[i]);
        }
        return 1;
    }
    if (strEQ(classname,CDblNAME)) {
        NV* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
            array[i] = SvNV(AvARRAY(av)[i]);
        }
        return 1;
    }
    if (strEQ(classname,CStrNAME)) {
        char *s;
        char** array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
            if ( SvPOK(AvARRAY(av)[i]) ) {
                s = SvPVX(AvARRAY(av)[i]);
                array[i] = safemalloc(strlen(s)+1);
                strcpy(array[i],s);
            }
        }
        return 1;
    }
    if (strEQ(classname,CInt2NAME)) {
        int2* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
	    /* dive into [[0,1][2,3]] */
            if (!SvROK(av)) return 0;
            av1 = (AV*) SvRV(AvARRAY(av)[i]);
            if (av_len(av1) >= 1) {
              array[i][0] = SvIV(AvARRAY(av1)[0]);
              array[i][1] = SvIV(AvARRAY(av1)[1]);
            }
        }
        return 1;
    }
    if (strEQ(classname,CInt3NAME)) {
        int3* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
	    /* dive into [[0,1,2][3,4,5]] */
            if (!SvROK(av)) return 0;
            av1 = (AV*)SvRV(AvARRAY(av)[i]);
            if (av_len(av1) >= 2) {
              array[i][0] = SvIV(AvARRAY(av1)[0]);
              array[i][1] = SvIV(AvARRAY(av1)[1]);
              array[i][2] = SvIV(AvARRAY(av1)[2]);
            }
        }
        return 1;
    }
    if (strEQ(classname,CInt4NAME)) {
        int4* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
            if (!SvROK(av)) return 0;
            av1 = (AV*)SvRV(AvARRAY(av)[i]);
            if (av_len(av1) >= 3) {
              array[i][0] = SvIV(AvARRAY(av1)[0]);
              array[i][1] = SvIV(AvARRAY(av1)[1]);
              array[i][2] = SvIV(AvARRAY(av1)[2]);
              array[i][3] = SvIV(AvARRAY(av1)[3]);
            }
        }
        return 1;
    }
    if (strEQ(classname,CDbl2NAME)) {
        double2* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
            if (!SvROK(av)) return 0;
            av1 = (AV*)SvRV(AvARRAY(av)[i]);
            if (av_len(av1) >= 1) {
              array[i][0] = SvNV(AvARRAY(av1)[0]);
              array[i][1] = SvNV(AvARRAY(av1)[1]);
            }
        }
        return 1;
    }
    if (strEQ(classname,CDbl3NAME)) {
        double3* array = carray->ptr;
        for (i=0; i <= min(avlen,len-1); i++) {
            if (!SvROK(av)) return 0;
            av1 = (AV*)SvRV(AvARRAY(av)[i]);
            if (av_len(av1) >= 2) {
              array[i][0] = SvNV(AvARRAY(av1)[0]);
              array[i][1] = SvNV(AvARRAY(av1)[1]);
              array[i][2] = SvNV(AvARRAY(av1)[2]);
            }
        }
        return 1;
    }
    return 0;
}

#ifndef OLD

static void
free_array_field_descriptor(Tie__CArray__SubArray *afields, int nfields)
{
    DBG_PRINTF(("free_array_field_descriptor(%p, $d)", afields, nfields));

    if (afields) {
	Tie__CArray__SubArray *ap = afields + nfields;

	while (--ap >= afields) {
	    if (ap->eltype == HASH_FIELDS) {
		free_hash_field_descriptor(ap->fields, ap->nfields);
	    }
	    else if (ap->eltype == ARRAY_FIELDS) {
		free_array_field_descriptor(ap->fields, ap->nfields);
	    }
	}
	Safefree(afields);
    }
}


static void
free_hash_field_descriptor(HASH_ELEMENT_T *hfields, int nfields)
{
    DBG_PRINTF(("free_hash_field_descriptor(%p, %d)", hfields, nfields));

    if (hfields) {
	Tie__CArray__SubHash *hp;

	for (hp = hfields; nfields-- > 0; hp++) {
	    if (hp->key) {
		Safefree(hp->key);
	    }
	    if (hp->eltype == HASH_FIELDS) {
		free_hash_field_descriptor(hp->fields, hp->nfields);
	    }
	    else if (hp->eltype == ARRAY_FIELDS) {
		free_array_field_descriptor(hp->fields, hp->nfields);
	    }
	}
	Safefree(hfields);
    }
}


/* Parse field descriptor.
 */
static int
parse_field_desc_array(Tie__CArray      *array,
		       ELEMENT_T        *field,
		       int	        offset,
		       AV               *desc_array)
{
    HASH_ELEMENT_T  *subfields;
    int	   	    nfields;
    int    	    i, j;
    SV              **p_name;
    SV              **p_template;
    char	    *name;
    char	    *template;
    STRLEN	    len;
    int		    elsize = 0;

    DBG_PRINTF(("parse_field_desc_array(%p, %p, %d, %p)",
	 array, field, offset, desc_array));
    ASSERT("parse_field_desc_array", SvTYPE(desc_array) == SVt_PVAV);

    /* Get the array length and ensure it is a non-zero multiple of two */

    nfields = 1 + av_len(desc_array);
    if (nfields == 0) {
	ABORT_CONSTRUCTOR(array, ("zero length array of fields"));
    }
    if (nfields % 2) {
	ABORT_CONSTRUCTOR(array, ("odd length array of fields (%d)", nfields));
    }
    nfields /= 2;


    /* Allocate the subfield array and fill in the pointers in the current field */

    Newz(0, subfields, nfields, HASH_ELEMENT_T);
    if (!subfields) {
        ABORT_CONSTRUCTOR(array, ("out of memory\n"));
    }

    DBG_PRINTF(("parse_field_desc_array  allocated %p-%p",
	   subfields, subfields + nfields));

    field->eltype  = HASH_FIELDS;
    field->fields  = subfields;
    field->nfields = nfields;

    /* Parse the names and descriptions of the individual fields */

    for (i = 0, j = 0; i < nfields; i++) {
	p_name = av_fetch(desc_array, j++, 0);
	p_template = av_fetch(desc_array, j++, 0);
	if (p_name == NULL || p_template == NULL || !SvPOK(*p_name)) {
	    ABORT_CONSTRUCTOR(array, ("invalid field description array element"));
	}
	SvGROW(*p_name, SvCUR(*p_name) + 1);
	name = SvPV(*p_name, len);
	name[len] = '\0';

	Newz(0, subfields[i].key, len + 1, char);
	strncpy(subfields[i].key, name, len+1);
	subfields[i].key[len] = '\0';
	subfields[i].offset   = offset + elsize;

	if (lookup_key(subfields, i, name)) {
	    ABORT_CONSTRUCTOR(array, ("duplicate field name"));
	}

	DBG_PRINTF(("parse_field_desc_array  field %d is \"%s\"", i, name));

	if (SvPOK(*p_template)) {
	    SvGROW(*p_template, SvCUR(*p_template) + 1);
	    template = SvPV(*p_template, len);
	    template[len] = '\0';
	    elsize += parse_field_desc_string(array, (ELEMENT_T *)&subfields[i],
					      offset + elsize, template);
	}
	else if (SvROK(*p_template) && SvTYPE(SvRV(*p_template)) == SVt_PVAV) {
	    elsize += parse_field_desc_array(array, (ELEMENT_T *)&subfields[i],
					     offset + elsize, (AV*)SvRV(*p_template));
	}
	else {
	    ABORT_CONSTRUCTOR(array, ("invalid field description array element"));
	}
    }
    field->elsize = elsize;

    return elsize;
}



static int
parse_field_desc_string(Tie__MmapArray  *array,
			ELEMENT_T       *field,
			int	   	offset,
			char            *template)
{
    ARRAY_ELEMENT_T	*subfields;
    int			elsize    = 0;
    int			totalsize = 0;
    int			nfields   = 0;
    char		*p;
    char 		*endp = template + strlen(template);
    char		ch;
    int			val;

    DBG_PRINTF(("parse_field_desc_string(array=%p, field=%p, offset=%d, template=\"%s\")",
	   array, field, offset, template));


    /* Determine the number of fields described by the string */

    for (p = template; p < endp; nfields++) {
	ch = *p++;
	if (p < endp && isdigit(*p)) {
	    val = strtol(p, &p, 10);
	    if (toupper(ch) != 'A' && ch != 'Z') {
		nfields += val - 1;
	    }
	}
    }


    /* If the pack string describes more than one field create an array field */

    if (nfields == 0) {
	ABORT_CONSTRUCTOR(array, ("invalid pack string \"%s\"", template));
    }
    else if (nfields == 1) {
	subfields = field;
    }
    else {
	Newz(0, subfields, nfields, ARRAY_ELEMENT_T);
	if (!subfields) {
	    ABORT_CONSTRUCTOR(array, ("out of memory\n"));
	}
	field->eltype  = ARRAY_FIELDS;
	field->fields  = subfields;
	field->nfields = nfields;
    }


    /* Process the field descriptors */

    for (p = template; p < endp; ) {
	ch = *p++;
	if (p < endp && isdigit(*p)) {
	    nfields = strtol(p, &p, 10);
	}
	else {
	    nfields = 1;
	}

	/* Check out the element type */

	if (toupper(ch) == 'A' || ch == 'Z') {
	    elsize  = nfields;
	    nfields = 1;
	}
	else {
	    switch (ch) {
	    case 'c': case 'C':
		elsize = sizeof(char);
		break;

	    case 's': case 'S': case 'n': case 'v':
		elsize = sizeof(short);
		break;

	    case 'i': case 'I':
		elsize = sizeof(int);
		break;

	    case 'l': case 'L': case 'N': case 'V':
		elsize = sizeof(long);
		break;

#if defined(USE_64_BITS) && defined(HAS_QUAD)
	    case 'q': case 'Q':
		elsize = sizeof(Quad_T);
		break;
#endif

	    default:
		ABORT_CONSTRUCTOR(array, ("unknown element type '%c'", ch));
	    }
	}
	while (nfields--) {
	    subfields->eltype = ch;
	    subfields->elsize = elsize;
	    subfields->offset = offset + totalsize;
	    totalsize += elsize;
	    subfields++;
	}
    }
    return totalsize;
}

/* Look-up a key in a sub-hash.
 * Currently performs a simple linear lookup.
 */
static HASH_ELEMENT_T *
lookup_key(HASH_ELEMENT_T   *fields,
	   int		    nfields,
	   char		    *key)
{
    if (nfields) {
	while (nfields--) {
	    if (strEQ(fields->key, key)) {
		return fields;
	    }
	    fields++;
	}
    }
    return NULL;
}

/* Fetch a subrecord reference.
 * Allocates and initializes a subrecord structure.
 * Increments the reference count of the main array
 * Blesses the subrecord to the appropriate type.
 * Creates and returns a tied hash or array.
 */
SV *
fetch_subrecord_reference(Tie__CArray    *array,
			  int		    recno,
			  char	    	    eltype,
			  void              *fieldp,
			  int		    nfields)
{
    SUBRECORD_REFERENCE_T   *subrec;
    SV			    *sv;
    SV			    *rv;
    SV			    *tied;

    DBG_PRINTF(("fetch_subrecord_reference(%p, %d, '%c', %p, %d)",
	   array, recno, isascii(eltype) ? eltype : '?', fieldp, nfields));

    /* Allocate a subrecord structure */

    New(0, subrec, 1, SUBRECORD_REFERENCE_T);
    if (!subrec) {
	croak("out of memory");
    }

    /* Initialize the subrecord structure */

    subrec->array   = array;
    subrec->recno   = recno;
    subrec->fields  = fieldp;
    subrec->nfields = nfields;

    /* Increment the reference count of the main array */

    array->refcnt++;

    /* Create and return a tied hash or array */
    /* Bless the subrecord to the appropriate type */

    sv = newSViv((int)subrec);
    rv = newRV_noinc(sv);

    if (eltype == ARRAY_FIELDS) {
	sv_bless(rv, gv_stashpv(SUBARRAY_PTR_CLASS, TRUE));
	tied = (SV *)newAV();
    }
    else {
	sv_bless(rv, gv_stashpv(SUBHASH_PTR_CLASS, TRUE));
	tied = (SV *)newHV();
	subrec->cur_index = 0;
    }

    hv_magic((HV*)tied, (GV*)rv, 'P');
    return newRV_noinc((SV*)tied);
}

/* Fetch a value from a specified address according
 * to the element type (sub-arrays and sub-hashes are handled
 * elsewhere).
 */
SV *
fetch_value(void *recaddr, char eltype, int elsize)
{
    SV			*sv;
    STRLEN		len;
    char        	*strval;
    char		*endp;
    int			intval;
    unsigned int	uintval;
    short		shortval;
    unsigned short	ushortval;
    long		longval;
    unsigned long       ulongval;
    float		floatval;
    NV		doubleval;
#ifdef HAVE_QUAD_INTS
    Quad_T		quadval;
    Uquad_T         uquadval;
#endif

    DBG_PRINTF(("fetch_value(%p, '%c', %d)", recaddr, isascii(eltype) ? eltype : '?', elsize));

    switch (eltype) {
    case 'A':
	for (strval = (char *)recaddr + elsize - 1; strval >= (char *)recaddr; strval--) {
	    if (*strval && *strval != ' ') {
		elsize = 1 + strval - (char *)recaddr;
		break;
	    }
	}
	sv = newSVpvn(recaddr, elsize);
	SvGROW(sv, elsize + 1);
	strval = SvPV(sv, len);
	strval[len] = '\0';
	return sv;

    case 'Z':
	for (strval = (char *)recaddr, endp = (char *)recaddr + elsize; strval < endp; strval++) {
	    if (*strval == '\0') {
		elsize = strval - (char *)recaddr;
		break;
	    }
	}
	sv = newSVpvn(recaddr, elsize);
	SvGROW(sv, elsize + 1);
	strval = SvPV(sv, len);
	strval[len] = '\0';
	return sv;

    case 'a':
	return newSVpvn(recaddr, elsize);

    case 'c':
	return newSViv((int) *(signed char *) recaddr);

    case 'C':
	return newSViv((unsigned int) *(unsigned char *)  recaddr);

    case 'n':
	GET_VAL(unsigned short, recaddr, ushortval);
	return newSViv((unsigned int)ntohs(ushortval));

    case 's':
	GET_VAL(short, recaddr, shortval);
	return newSViv((int)shortval);

    case 'S':
	GET_VAL(unsigned short, recaddr, ushortval);
	return newSViv((unsigned int)ushortval);

    case 'i':
	GET_VAL(int, recaddr, intval);
	return newSViv(intval);

    case 'I':
	GET_VAL(unsigned int, recaddr, uintval);
	return newSViv(uintval);

    case 'l':
	GET_VAL(long, recaddr, longval);
	return newSViv(longval);

    case 'L':
	GET_VAL(unsigned long, recaddr, ulongval);
	return newSViv(ulongval);

    case 'N':
	GET_VAL(unsigned long, recaddr, ulongval);
	return newSViv((unsigned long)ntohl(ulongval));

#if defined(USE_64_BITS) && defined(HAS_QUAD)
    case 'q':
	GET_VAL(Quad_T, recaddr, quadval);
	return newSVnv((NV) quadval);

    case 'Q':
	GET_VAL(Uquad_T, recaddr, uquadval);
#ifdef _MSC_VER
        /* msvc <= 6 cannot coerce ulonglong to double, only signed */
	return newSVnv((NV)(Quad_T)uquadval);
#else
	return newSVnv((NV) uquadval);
#endif
#endif

    case 'f':
	GET_VAL(float, recaddr, floatval);
	return newSVnv((NV) floatval);

    case 'd':
	GET_VAL(NV, recaddr, doubleval);
	return newSVnv(doubleval);

    default:
	croak("internal error (FETCH: case %d not handled)", eltype);
    }
}

/* Store a value at a specified address according to the element type.
 */
SV *
store_value(void *recaddr, char eltype, int elsize, SV *value)
{
    STRLEN		len;
    char        	*strval;
    signed char		charval;
    unsigned char	ucharval;
    int			intval;
    unsigned int	uintval;
    short		shortval;
    unsigned short	ushortval;
    long		longval;
    unsigned long       ulongval;
    float		floatval;
    NVTYPE		doubleval;
#if defined(USE_64_BITS) && defined(HAS_QUAD)
    Quad_T          quadval;
    Uquad_T         uquadval;
#endif

    DBG_PRINTF(("store_value(%p, %d, %d, %p)", recaddr, eltype, elsize, value));

    switch (eltype) {
    case 'a':
    case 'A':
    case 'Z':
	strval = SvPV(value, len);
	if (len > elsize) {
	    len = elsize;
	}
	Copy(strval, recaddr, len, char);
	if (len < elsize) {
	    if (eltype == 'a') {
                Zero((char *)recaddr + len, elsize - len, char);
	    }
	    else {
                memset((char *)recaddr + len, ' ', elsize - len);
	    }
	}
	return newSVpvn(recaddr, elsize);

    case 'c':
	charval = (signed char)SvIV(value);
	*(signed char *)recaddr = charval;
	return newSViv((int) charval);

    case 'C':
	ucharval = (unsigned char)SvIV(value);
	*(unsigned char *)recaddr = ucharval;
	return newSViv((unsigned int) ucharval);

    case 's':
	shortval = (short)SvIV(value);
	SET_VAL(short, recaddr, shortval);
	return newSViv((int) shortval);

    case 'S':
	ushortval = (unsigned short)SvIV(value);
	SET_VAL(unsigned short, recaddr, ushortval);
	return newSViv((unsigned int) ushortval);

    case 'i':
	intval = (int)SvIV(value);
	SET_VAL(int, recaddr, intval);
	return newSViv((int) intval);

    case 'I':
	uintval = (unsigned int)SvIV(value);
	SET_VAL(unsigned int, recaddr, uintval);
	return newSViv((unsigned int) uintval);

    case 'l':
	longval = (long)SvIV(value);
	SET_VAL(long, recaddr, intval);
	return newSViv(longval);

    case 'L':
	ulongval = (unsigned long)SvIV(value);
	SET_VAL(unsigned long, recaddr, ulongval);
	return newSViv(ulongval);

#if defined(USE_64_BITS) && defined(HAS_QUAD)
    case 'q':
	quadval = (Quad_T)SvNV(value);
	SET_VAL(Quad_T, recaddr, quadval);
	return newSVnv((NV)quadval);

    case 'Q':
	uquadval = (Uquad_T)SvNV(value);
	SET_VAL(Uquad_T, recaddr, uquadval);
#ifdef _MSC_VER
        /* msvc <= 6 cannot coerce ulonglong to double, only signed */
	return newSVnv((NV)(Quad_T)uquadval);
#else
	return newSVnv((NV)uquadval);
#endif
#endif

    case 'f':
	floatval = (float)SvNV(value);
	SET_VAL(float, recaddr, floatval);
	return newSVnv(floatval);

    case 'F':
	doubleval = (NV)SvNV(value);
	SET_VAL(NV, recaddr, doubleval);
	return newSVnv(doubleval);

    case ARRAY_FIELDS:
    case HASH_FIELDS:
	croak("cannot change element structure");

    default:
	croak("internal error (STORE: case %d not handled)", eltype);
    }
}
#endif /* OLD */


/* ***************************************************************** */

#line 1051 "CArray.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 1195 "CArray.c"

XS_EUPXS(XS_Tie__CArray_XS_rcs_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_XS_rcs_string)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 1047 "CArray.xs"
 RETVAL = RCS_STRING;
#line 1208 "CArray.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CArray_XS_compile_date); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_XS_compile_date)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    {
	char *	RETVAL;
	dXSTARG;
#line 1054 "CArray.xs"
 RETVAL = __DATE__ " " __TIME__;
#line 1226 "CArray.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CArray_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CArray *	carray;
#line 1062 "CArray.xs"
    SV *this = ST(0);
    char *old;
#line 1244 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1065 "CArray.xs"
#ifdef MYDEBUG_FREE
    DBG_PRINTF(("XSDbg: free (%p,->%p)\n",carray, carray->ptr));
/*  DBG_PRINTF(("    => (refSV: %d, RV: %p, IVRV: %p, refRV: %d)\n",
      SvREFCNT(ST(0)), SvRV(ST(0)), SvIV(SvRV(ST(0))), SvREFCNT(SvRV(ST(0))) ));
 */
#endif
    old = (char *) carray;
    if (carray) {
      if (carray->ptr) safefree ((char *) carray->ptr);
      /* safefree ((char *) carray); */
    }
/* if (old == (char *) carray)
     carray->ptr=0;
   SvROK_off (this);
   SvREFCNT (this)--;
*/
#ifdef MYDEBUG_FREE
    DBG_PRINTF((" unref (refSV: %d, RV: %p, IVRV: %p, refRV: %d)\n",
	SvREFCNT(this), SvRV(this), SvIV(SvRV(this)), SvREFCNT(SvRV(this)) ));
#endif
#line 1275 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CArray_len); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_len)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1092 "CArray.xs"
    /* sequential classes must divide this */
    RETVAL = carray->len;
#line 1304 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CArray__freelen); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray__freelen)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1101 "CArray.xs"
    /* Return the number of elements to be added without copying. (if elsize is byte)
     * Sequential classes must divide this by their resp. itemsizes */
    RETVAL = carray->freelen;
#line 1334 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CArray_grow); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_grow)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, n");
    {
	Tie__CArray *	carray;
	int	n = (int)SvIV(ST(1))
;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1115 "CArray.xs"
    if (ix < 2) {			/* grow or EXTEND */
      grow (carray, n, mysv_itemsize( ST(0) ));
    } else {                            /* change size */
      if (n > carray->len)              /* EXTEND */
      	grow (carray, n-carray->len, mysv_itemsize( ST(0) ));
      else {				/* SHRINK */
	carray->freelen += carray->len - n;
	carray->len = n;
      }
    }
#line 1372 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CArray_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CArray *	carray;
	int	index = (int)SvIV(ST(1))
;
#line 1131 "CArray.xs"
    char *array;
    int itemsize;
#line 1391 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1134 "CArray.xs"
    if ((index < 0) || (index >= carray->len))
      croak (ErrMsg_index);
    /* deletes one item at index, there's no shrink */
    carray->freelen++;
    carray->len--;
    if (index < carray->len-1) {
        itemsize = mysv_itemsize( ST(0) );
        array = (char *) carray->ptr + (index*itemsize);
        memcpy (array, array + itemsize, itemsize*(carray->len - index));
    }
#line 1412 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CArray_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_copy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CArray *	carray;
#line 1149 "CArray.xs"
    SV * this = ST(0);
    int itemsize, len;
    Tie__CArray * ncarray;
#line 1430 "CArray.c"
	Tie__CArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1153 "CArray.xs"
    itemsize = mysv_itemsize( this );
    len = carray->len;
    NEW_CARRAY(ncarray,Tie__CArray,len,itemsize);
    memcpy (ncarray->ptr, carray->ptr, itemsize * len);
    RETVAL = carray;
#line 1447 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CArray_nreverse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_nreverse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CArray *	carray;
#line 1165 "CArray.xs"
    char *up, *down, *tmp;                      /* pointers incrementable by 1 byte */
    int len, itemsize;
#line 1470 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1168 "CArray.xs"
    /* Generic reverse in place. Returns nothing */
    len = carray->len;
    if (!len)  XSRETURN_NO;
    tmp = (char *) safemalloc (MAXITEMSIZE);
/*  if (!carray->ptr) XSRETURN_NO; */
    /* get the itemsize to swap: there's a XSUB cv ->itemsize */
    itemsize = mysv_itemsize( ST(0) );
    if (!itemsize)  croak (ErrMsg_itemsize);
    /* */
    down = (char *)carray->ptr + ((len-1)*itemsize);
    up   = (char *)carray->ptr;
    while ( down > up )
    {
      memcpy(tmp,  up,   itemsize);
      memcpy(up,   down, itemsize);
      memcpy(down, tmp,  itemsize);
      up   += itemsize;
      down -= itemsize;
    }
    safefree(tmp);
    XSRETURN_EMPTY;
#line 1502 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CArray_CLEAR); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_CLEAR)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CArray *	carray;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;
#line 1194 "CArray.xs"
    Zero(carray->ptr, carray->len * carray->elsize, void *);
#line 1527 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CArray_init); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CArray_init)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "carray, av");
    {
	Tie__CArray *	carray;
	AV *	av;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CArray *, tmp);
	} else {
          croak("carray is not of type Tie::CArray");
	}
;

        if (SvROK(ST(1))) av = (AV*)SvRV(ST(1));
	else croak("av is no ARRAYREF")
;
#line 1203 "CArray.xs"
    if (!av) XSRETURN_EMPTY;
    myarray_init(g_classname, carray, av);
#line 1558 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CIntArray_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CIntArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1214 "CArray.xs"
    RETVAL = sizeof(IV);
#line 1585 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CIntArray_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_new)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1224 "CArray.xs"
    SV * this = ST(0);
    int  len;
    AV * av;
    Tie__CIntArray *carray;
    IV * array;
    int i, avlen;
    /* */
    if (items < 1 || items > 3)
	if (ix == 0)
            croak("Usage: new Tie::CIntArray(len, [AVPtr])");
	else
            croak("Usage: tie @array, Tie::CIntArray, len, [AVPtr]");
    {
      /* need to check for ->new invocation, we'll have 3 args then */
      g_classname = mysv_classname(this);
      if ( g_classname  ) {
          len = (int)SvIV(ST(1));
          av   = (items == 3) ? av = (AV*)SvRV(ST(2)) : NULL;
      } else {
          g_classname = CIntNAME;
          len = (int)SvIV(ST(0));
          av   = (items == 2) ? av = (AV*)SvRV(ST(1)) : NULL;
      }
      /* make room: freesize leaves room for certain more items */
      NEW_CARRAY(carray,Tie__CIntArray,len,sizeof(IV));
      if (av) {
        /* for derived classes we'll have a problem here!
        * we could either check the classname for ints,
        * or provide seperate initializers (in perl) */
/*      if (!strEQ(g_classname,CIntNAME)) {
          warn("can only initialize %s",CIntNAME);
        } else
*/
          myarray_init(g_classname, (Tie__CArray *)carray, av);
      }
      EXTEND(sp, 1);
      ST(0) = sv_newmortal();
      sv_setref_pv(ST(0), g_classname, (void*)carray);
      XSRETURN(1);
    }
#line 1643 "CArray.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__CIntArray_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1272 "CArray.xs"
    if ((index < 0) || (index >= carray->len))
      croak (ErrMsg_index);
/*  DBG_PRINTF(("XSDbg: get (%p,%d)",array,index)); */
    RETVAL = carray->ptr[index];
/*  DBG_PRINTF((" => %d\n",array[index])); */
#line 1678 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CIntArray_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	int	value = (int)SvIV(ST(2))
;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1288 "CArray.xs"
{
  if ((index < 0) || (index >= carray->len))
    croak (ErrMsg_index);
/*  DBG_PRINTF(("XSDbg: set (%p,%d,%d)\n",array,index,value)); */
  carray->ptr[index] = value;
}
#line 1714 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CIntArray_ToInt2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_ToInt2)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "x, y, dst=0");
    {
	Tie__CIntArray *	x;
	Tie__CIntArray *	y;
	Tie__CIntArray *	dst = (items == 3) ? dst = (Tie__CIntArray *)SvRV(ST(2)) : NULL;
#line 1301 "CArray.xs"
  int i, len;
  int2 *dstp;
#line 1733 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  x = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("x is not of type Tie::CIntArray");
	}
;

	g_classname = mysv_classname(ST(1));
        if (sv_derived_from(ST(1), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(1)));
	  y = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("y is not of type Tie::CIntArray");
	}
;
#line 1304 "CArray.xs"
  /* convert two parallel int *x,*y to one int[2] */
  /* if dst, which must be preallocated, copy it to this location */
  len = x->len;
  if (!dst) {
    NEW_CARRAY(dst,Tie__CIntArray,len,sizeof(int2));
  } else {
    CHECK_DERIVED_FROM(2,CIntNAME);
    MAYBE_GROW_CARRAY(dst,Tie__CIntArray,len,sizeof(int2));
  }
  dstp = (int2 *)dst->ptr;
  if (min(x->len,y->len) == len)
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        dstp[i][1] = y->ptr[i];
    }
  else                                  /* safe init */
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        if (i < y->len) dstp[i][1] = y->ptr[i]; else dstp[i][1] = 0;
    }
  dst->len = len * 2;
  ST(0) = sv_newmortal();
  /* blessing makes problems: it is returned as "CIntArray" object. */
  sv_setref_pv(ST(0), CInt2NAME, (void*)dst);
#line 1777 "CArray.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CIntArray_ToInt3); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_ToInt3)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "x, y, z, dst=0");
    {
	Tie__CIntArray *	x;
	Tie__CIntArray *	y;
	Tie__CIntArray *	z;
	Tie__CIntArray *	dst = (items > 3) ? dst = (Tie__CIntArray *)SvRV(ST(3)) : NULL;
#line 1336 "CArray.xs"
  int i, len;
  int3 *dstp;
#line 1797 "CArray.c"
	Tie__CIntArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  x = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("x is not of type Tie::CIntArray");
	}
;

	g_classname = mysv_classname(ST(1));
        if (sv_derived_from(ST(1), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(1)));
	  y = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("y is not of type Tie::CIntArray");
	}
;

	g_classname = mysv_classname(ST(2));
        if (sv_derived_from(ST(2), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(2)));
	  z = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("z is not of type Tie::CIntArray");
	}
;
#line 1339 "CArray.xs"
  len = x->len;
  if (!dst) {
    NEW_CARRAY(dst,Tie__CIntArray,len,sizeof(int3));
  } else {
    CHECK_DERIVED_FROM(3,CIntNAME);
    MAYBE_GROW_CARRAY(dst,Tie__CIntArray,len,sizeof(int3));
  }
  dstp = (int3 *) dst->ptr;
  if (min(min(x->len,y->len),z->len) == len)
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        dstp[i][1] = y->ptr[i];
        dstp[i][2] = z->ptr[i];
    }
  else                                  /* safe init */
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        if (i < y->len) dstp[i][1] = y->ptr[i]; else dstp[i][1] = 0;
        if (i < z->len) dstp[i][2] = z->ptr[i]; else dstp[i][2] = 0;
    }
  dst->len = len * 3;
  g_classname = CInt3NAME;
  RETVAL = dst;
#line 1850 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CIntArray_ToInt4); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_ToInt4)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "x, y, z, w, dst=0");
    {
	Tie__CIntArray *	x;
	Tie__CIntArray *	y;
	Tie__CIntArray *	z;
	Tie__CIntArray *	w;
	Tie__CIntArray *	dst = (items > 4) ? dst = (Tie__CIntArray *)SvRV(ST(4)) : NULL;
#line 1373 "CArray.xs"
  int i, len;
  int4 *dstp;
#line 1877 "CArray.c"
	Tie__CIntArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  x = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("x is not of type Tie::CIntArray");
	}
;

	g_classname = mysv_classname(ST(1));
        if (sv_derived_from(ST(1), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(1)));
	  y = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("y is not of type Tie::CIntArray");
	}
;

	g_classname = mysv_classname(ST(2));
        if (sv_derived_from(ST(2), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(2)));
	  z = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("z is not of type Tie::CIntArray");
	}
;

	g_classname = mysv_classname(ST(3));
        if (sv_derived_from(ST(3), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(3)));
	  w = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("w is not of type Tie::CIntArray");
	}
;
#line 1376 "CArray.xs"
  len = x->len;
  if (!dst) {
    NEW_CARRAY(dst,Tie__CIntArray,len,sizeof(int4));
  } else {
    CHECK_DERIVED_FROM(4,CIntNAME);
    MAYBE_GROW_CARRAY(dst,Tie__CIntArray,len,sizeof(int4));
  }
  dstp = (int4 *) dst->ptr;
  if ( min (min (x->len,y->len), min (z->len,w->len)) == len)
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        dstp[i][1] = y->ptr[i];
        dstp[i][2] = z->ptr[i];
        dstp[i][3] = w->ptr[i];
    }
  else                                  /* safe init */
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        if (i < y->len) dstp[i][1] = y->ptr[i]; else dstp[i][1] = 0;
        if (i < z->len) dstp[i][2] = z->ptr[i]; else dstp[i][2] = 0;
        if (i < w->len) dstp[i][3] = w->ptr[i]; else dstp[i][3] = 0;
    }
  dst->len = len * 4;
  g_classname = CInt4NAME;
  RETVAL = dst;
#line 1941 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CIntArray_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CIntArray_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CIntArray *	carray;
#line 1408 "CArray.xs"
    int i, len;
    IV *array;
#line 1964 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1411 "CArray.xs"
    RETVAL = newAV();
    len = carray->len;
    array = carray->ptr;
    for (i=0; i<len; i++ ) {
        av_push(RETVAL, sv_2mortal( newSViv( array[i] )));
    }
#line 1982 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt2Array_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt2Array_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CIntArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1428 "CArray.xs"
  RETVAL = sizeof(int2);
#line 2015 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt2Array_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt2Array_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
#line 1439 "CArray.xs"
    int2 *array;
    AV *av;
#line 2036 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1442 "CArray.xs"
  if ((index < 0) || (index >= carray->len/2))
    croak (ErrMsg_index);
  array = (int2 *) carray->ptr;
  if (GIMME == G_ARRAY) {
    XST_mIV(0,array[index][0]);
    XST_mIV(1,array[index][1]);
    XSRETURN(2);
  } else {
    av = newAV();
    av_push(av, newSViv( array[index][0] ));
    av_push(av, newSViv( array[index][1] ));
    ST(0) = sv_2mortal(newRV((SV*) av));
    XSRETURN(1);
  }
#line 2061 "CArray.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt2Array_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt2Array_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	AV *	value;
#line 1465 "CArray.xs"
  int i, len;
  int2 *array;
#line 2082 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;

        if (SvROK(ST(2))) value = (AV*)SvRV(ST(2));
	else croak("value is no ARRAYREF")
;
#line 1468 "CArray.xs"
  if ((index < 0) || (index >= carray->len/2))
    croak (ErrMsg_index);
  array = (int2 *) carray->ptr;
  len = min(av_len(value)+1,2);
  for (i=0; i < len; i++) {
    array[index][i] = SvIV(AvARRAY(value)[i]);
  }
#line 2104 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CInt2Array_ToPar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt2Array_ToPar)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "carray, x=0, y=0");
    {
	Tie__CIntArray *	carray;
	Tie__CIntArray *	x = (items > 1)  ? x = (Tie__CIntArray *) SvRV(ST(1)) : NULL;
	Tie__CIntArray *	y = (items > 2)  ? y = (Tie__CIntArray *) SvRV(ST(2)) : NULL;
#line 1482 "CArray.xs"
  int i, len;
  int3 *array;
#line 2123 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1485 "CArray.xs"
  /* convert one int[3] to parallel ints *x,*y,*z */
  /* if dst, which must be preallocated, copy it to this location. */
  /* return an arrayref to the three objects */
  len = carray->len / 3;
  array = (int3 *) carray->ptr;
  if (!x) {
    NEW_CARRAY(x,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(1,CIntNAME);
    MAYBE_GROW_CARRAY(x,Tie__CIntArray,len,sizeof(IV));
  }
  if (!y) {
    NEW_CARRAY(y,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(2,CIntNAME);
    MAYBE_GROW_CARRAY(y,Tie__CIntArray,len,sizeof(IV));
  }
  for (i=0; i < len; i++) {
    x->ptr[i] = array[i][0];
    y->ptr[i] = array[i][1];
  }
  /* if (items < 3) EXTEND(sp,1);// one more */
  RETVAL = newAV();
  av_push(RETVAL, sv_setref_pv( sv_newmortal(), CIntNAME, (void*)x));
  av_push(RETVAL, sv_setref_pv( sv_newmortal(), CIntNAME, (void*)y));
#line 2160 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt3Array_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt3Array_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CIntArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1520 "CArray.xs"
  RETVAL = sizeof(int3);
#line 2193 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt3Array_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt3Array_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
#line 1531 "CArray.xs"
  int3 *array;
  AV *av;
#line 2214 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1534 "CArray.xs"
  if ((index < 0) || (index >= carray->len/3))
    croak (ErrMsg_index);
  array = (int3 *) carray->ptr;
  if (GIMME == G_ARRAY) {
    EXTEND(sp,1);
    XST_mIV(0,array[index][0]);
    XST_mIV(1,array[index][1]);
    XST_mIV(2,array[index][2]);
    XSRETURN(3);
  } else {
    av = newAV();
    av_push(av, newSViv( array[index][0] ));
    av_push(av, newSViv( array[index][1] ));
    av_push(av, newSViv( array[index][2] ));
    ST(0) = sv_2mortal(newRV((SV*) av));
    XSRETURN(1);
  }
#line 2242 "CArray.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt3Array_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt3Array_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	AV *	value;
#line 1560 "CArray.xs"
  int i, len;
  int3 *array;
#line 2263 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;

        if (SvROK(ST(2))) value = (AV*)SvRV(ST(2));
	else croak("value is no ARRAYREF")
;
#line 1563 "CArray.xs"
  if ((index < 0) || (index >= carray->len/3))
    croak (ErrMsg_index);
  array = (int3 *) carray->ptr;
  len = min(av_len(value)+1,3);
  for (i=0; i < len; i++) {
    array[index][i] = SvIV(AvARRAY(value)[i]);
  }
#line 2285 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CInt3Array_ToPar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt3Array_ToPar)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "carray, x=0, y=0, z=0");
    {
	Tie__CIntArray *	carray;
	Tie__CIntArray *	x = (items > 1) ? x = (Tie__CIntArray *) SvRV(ST(1)) : NULL;
	Tie__CIntArray *	y = (items > 2) ? y = (Tie__CIntArray *) SvRV(ST(2)) : NULL;
	Tie__CIntArray *	z = (items > 3) ? z = (Tie__CIntArray *) SvRV(ST(3)) : NULL;
#line 1578 "CArray.xs"
  int i, len;
  int3 *array;
#line 2305 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1581 "CArray.xs"
  /* convert one int[3] to parallel ints *x,*y,*z */
  /* if dst, which must be preallocated, copy it to this location */
  /* return an arrayref to the three objects */
  len = carray->len / 3;
  array = (int3 *) carray->ptr;
  if (!x) {
    NEW_CARRAY(x,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(1,CIntNAME);
    MAYBE_GROW_CARRAY(x,Tie__CIntArray,len,sizeof(IV));
  }
  if (!y) {
    NEW_CARRAY(y,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(2,CIntNAME);
    MAYBE_GROW_CARRAY(y,Tie__CIntArray,len,sizeof(IV));
  }
  if (!z) {
    NEW_CARRAY(z,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(3,CIntNAME);
    MAYBE_GROW_CARRAY(z,Tie__CIntArray,len,sizeof(IV));
  }
  for (i=0; i < len; i++) {
    x->ptr[i] = array[i][0];
    y->ptr[i] = array[i][1];
    z->ptr[i] = array[i][2];
  }
  /* if (items < 3) EXTEND(sp,1);// one more */
  RETVAL = newAV();
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)x));
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)y));
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)z));
#line 2350 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt4Array_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt4Array_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CIntArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1624 "CArray.xs"
  RETVAL = sizeof(int4);
#line 2383 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt4Array_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt4Array_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
#line 1635 "CArray.xs"
  int4 *array;
  AV   *av;
#line 2404 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1638 "CArray.xs"
  if ((index < 0) || (index >= carray->len/4))
    croak (ErrMsg_index);
  array = (int4 *) carray->ptr;
  if (GIMME == G_ARRAY) {
    EXTEND(sp,2);
    XST_mIV(0,array[index][0]);
    XST_mIV(1,array[index][1]);
    XST_mIV(2,array[index][2]);
    XST_mIV(3,array[index][3]);
    XSRETURN(4);
  } else {
    av = newAV();
    av_push(av, newSViv( array[index][0] ));
    av_push(av, newSViv( array[index][1] ));
    av_push(av, newSViv( array[index][2] ));
    av_push(av, newSViv( array[index][3] ));
    ST(0) = sv_2mortal(newRV((SV*) av));
    XSRETURN(1);
  }
#line 2434 "CArray.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CInt4Array_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt4Array_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CIntArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	AV *	value;
#line 1666 "CArray.xs"
  int i, len;
  int4 *array;
#line 2455 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;

        if (SvROK(ST(2))) value = (AV*)SvRV(ST(2));
	else croak("value is no ARRAYREF")
;
#line 1669 "CArray.xs"
  if ((index < 0) || (index >= carray->len/4))
    croak (ErrMsg_index);
  array = (int4 *) carray->ptr;
  len = min(av_len(value)+1,4);
  for (i=0; i < len; i++) {
    array[index][i] = SvIV(AvARRAY(value)[i]);
  }
#line 2477 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CInt4Array_ToPar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CInt4Array_ToPar)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "carray, x=0, y=0, z=0, w=0");
    {
	Tie__CIntArray *	carray;
	Tie__CIntArray *	x = (items > 1) ? x = (Tie__CIntArray *) SvRV(ST(1)) : NULL;
	Tie__CIntArray *	y = (items > 2) ? y = (Tie__CIntArray *) SvRV(ST(2)) : NULL;
	Tie__CIntArray *	z = (items > 3) ? z = (Tie__CIntArray *) SvRV(ST(3)) : NULL;
	Tie__CIntArray *	w = (items > 4) ? w = (Tie__CIntArray *) SvRV(ST(4)) : NULL;
#line 1685 "CArray.xs"
  int i, len;
  int4 *array;
#line 2498 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CIntArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CIntArray *, tmp);
	} else {
          croak("carray is not of type Tie::CIntArray");
	}
;
#line 1688 "CArray.xs"
  len = carray->len / 4;
  array = (int4 *) carray->ptr;
  if (!x) {
    NEW_CARRAY(x,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(1,CIntNAME);
    MAYBE_GROW_CARRAY(x,Tie__CIntArray,len,sizeof(IV));
  }
  if (!y) {
    NEW_CARRAY(y,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(2,CIntNAME);
    MAYBE_GROW_CARRAY(y,Tie__CIntArray,len,sizeof(IV));
  }
  if (!z) {
    NEW_CARRAY(z,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(3,CIntNAME);
    MAYBE_GROW_CARRAY(z,Tie__CIntArray,len,sizeof(IV));
  }
  if (!w) {
    NEW_CARRAY(w,Tie__CIntArray,len,sizeof(IV));
  } else {
    CHECK_DERIVED_FROM(4,CIntNAME);
    MAYBE_GROW_CARRAY(w,Tie__CIntArray,len,sizeof(IV));
  }
  for (i=0; i < len; i++) {
    x->ptr[i] = array[i][0];
    y->ptr[i] = array[i][1];
    z->ptr[i] = array[i][2];
    w->ptr[i] = array[i][3];
  }
  RETVAL = newAV();
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)x));
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)y));
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)z));
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CIntNAME, (void*)w));
#line 2547 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDoubleArray_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CDoubleArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1735 "CArray.xs"
  RETVAL = sizeof(NV);
#line 2580 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDoubleArray_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_new)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 1744 "CArray.xs"
    SV * this = ST(0);
    int  len;
    AV * av;
    Tie__CDoubleArray *carray;
    NV *array;
    int i, avlen;
    /* */
    if (items < 1 || items > 3)
	if (ix == 0)
            croak("Usage: new Tie::CDoubleArray(len, [AVPtr])");
	else
            croak("Usage: tie @array, 'Tie::CDoubleArray', len, [AVPtr]");
    {
    	/* need to check for ->new invocation, we'll have 3 args then */
    	g_classname = mysv_classname(this);
    	if ( g_classname  ) {
            len = (int)SvIV(ST(1));
            av   = (items == 3) ? av = (AV*)SvRV(ST(2)) : NULL;
    	} else {
	    g_classname = CDblNAME;
	    len = (int)SvIV(ST(0));
            av   = (items == 2) ? av = (AV*)SvRV(ST(1)) : NULL;
    	}
        /* make room */
        NEW_CARRAY(carray,Tie__CDoubleArray,len,sizeof(NV));
        carray->len = len;
    	if (av) {
      	    /* initializing section: */
      	    /* for derived classes we'll have a problem here! */
      	    /* we could either check the classname for ints, */
      	    /* or call seperate initializers (in perl) */
      	    if (!strEQ(g_classname,CDblNAME))
            	warn("can only initialize %s",CDblNAME);
  	    else
                myarray_init(g_classname, (Tie__CArray *)carray, av);
    	}
    	ST(0) = sv_newmortal();
    	sv_setref_pv(ST(0), g_classname, (void*)carray);
    	XSRETURN(1);
    }
#line 2638 "CArray.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__CDoubleArray_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CDoubleArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	NV	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1793 "CArray.xs"
    if ((index < 0) || (index >= carray->len))
        croak (ErrMsg_index);
    RETVAL = carray->ptr[index];
#line 2671 "CArray.c"
	XSprePUSH; PUSHn((NV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDoubleArray_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CDoubleArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	NV	value = (NV)SvNV(ST(2))
;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1807 "CArray.xs"
    if ((index < 0) || (index >= carray->len))
        croak (ErrMsg_index);
    carray->ptr[index] = value;
#line 2704 "CArray.c"
    }
    XSRETURN_EMPTY;
}

#if 0
#define XSubPPtmpAAAA 1


XS_EUPXS(XS_Tie__CDoubleArray_nreverse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_nreverse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CDoubleArray *	carray;
#line 1818 "CArray.xs"
    int len;
    NV *up, *down, tmp;
#line 2724 "CArray.c"
	Tie__CDoubleArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1821 "CArray.xs"
    len = carray->len;
    if (!len)  XSRETURN_EMPTY;
    if (!carray->ptr) XSRETURN_EMPTY;
    /* fast reverse in place */
    down = &carray->ptr[len-1];
    up   = &carray->ptr[0];
    while ( down > up )
    {
    	tmp = *up;
    	*up++ = *down;
    	*down-- = tmp;
    }
    RETVAL = carray;
#line 2749 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#endif

XS_EUPXS(XS_Tie__CDoubleArray_ToDouble2); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_ToDouble2)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "x, y, dst=0");
    {
	Tie__CDoubleArray *	x;
	Tie__CDoubleArray *	y;
	Tie__CDoubleArray *	dst = (items > 2) ? dst = (Tie__CDoubleArray *)SvRV(ST(2)) : NULL;
#line 1845 "CArray.xs"
  int i, len;
  NV *xp, *yp;
  double2 *dstp;
#line 2776 "CArray.c"
	Tie__CDoubleArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  x = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("x is not of type Tie::CDoubleArray");
	}
;

	g_classname = mysv_classname(ST(1));
        if (sv_derived_from(ST(1), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(1)));
	  y = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("y is not of type Tie::CDoubleArray");
	}
;
#line 1849 "CArray.xs"
  len = x->len;
  if (!dst) {
    NEW_CARRAY(dst,Tie__CDoubleArray,len,sizeof(double2));
  } else {
    CHECK_DERIVED_FROM(2,CDblNAME);
    MAYBE_GROW_CARRAY(dst,Tie__CDoubleArray,len,sizeof(double2));
  }
  dstp = (double2 *) dst->ptr;
  if (min(x->len,y->len) == len)
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        dstp[i][1] = y->ptr[i];
    }
  else                                  /* safe init */
    for (i=0; i < len; i++) {
        if (i < x->len) dstp[i][0] = x->ptr[i]; else dstp[i][0] = 0.0;
        if (i < y->len) dstp[i][0] = y->ptr[i]; else dstp[i][1] = 0.0;
    }
  dst->len = len * 2;
  g_classname = CDbl2NAME;
  RETVAL = dst;
#line 2818 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDoubleArray_ToDouble3); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_ToDouble3)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "x, y, z=0, dst=0");
    {
	Tie__CDoubleArray *	x;
	Tie__CDoubleArray *	y;
	Tie__CDoubleArray *	z = (items > 2) ? z   = (Tie__CDoubleArray *)SvRV(ST(2)) : NULL;
	Tie__CDoubleArray *	dst = (items > 3) ? dst = (Tie__CDoubleArray *)SvRV(ST(3)) : NULL;
#line 1880 "CArray.xs"
  int i, len;
  double3 *dstp;
#line 2844 "CArray.c"
	Tie__CDoubleArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  x = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("x is not of type Tie::CDoubleArray");
	}
;

	g_classname = mysv_classname(ST(1));
        if (sv_derived_from(ST(1), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(1)));
	  y = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("y is not of type Tie::CDoubleArray");
	}
;
#line 1883 "CArray.xs"
  len = x->len;
  CHECK_DERIVED_FROM(2,CDblNAME);
  if (!dst) {
    NEW_CARRAY(dst,Tie__CDoubleArray,len,sizeof(double3));
  } else {
    CHECK_DERIVED_FROM(3,CDblNAME);
    MAYBE_GROW_CARRAY(dst,Tie__CDoubleArray,len,sizeof(double3));
  }
  dstp = (double3 *) dst->ptr;
  if (min(min(x->len,y->len),z->len) == len)
    for (i=0; i < len; i++) {
        dstp[i][0] = x->ptr[i];
        dstp[i][1] = y->ptr[i];
        dstp[i][2] = z ? z->ptr[i] : 0.0;
    }
  else                                  /* safe init */
    for (i=0; i < len; i++) {
        if (i < x->len) dstp[i][0] = x->ptr[i]; else dstp[i][0] = 0.0;
        if (i < y->len) dstp[i][0] = y->ptr[i]; else dstp[i][1] = 0.0;
        if (z && (i < z->len)) dstp[i][0] = z->ptr[i]; else dstp[i][2] = 0.0;
    }
  dst->len = len * 3;
  g_classname = CDbl3NAME;
  RETVAL = dst;
#line 2889 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDoubleArray_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDoubleArray_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CDoubleArray *	carray;
#line 1914 "CArray.xs"
    int i, len;
    NV *array;
#line 2912 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1917 "CArray.xs"
    RETVAL = newAV();
    len = carray->len;
    array = carray->ptr;
    for (i=0; i<len; i++ ) {
        av_push(RETVAL, sv_2mortal( newSVnv( array[i] )));
    }
#line 2930 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDouble2Array_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble2Array_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CDoubleArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1933 "CArray.xs"
  RETVAL = sizeof(double2);
#line 2963 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDouble2Array_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble2Array_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CDoubleArray *	carray;
	int	index = (int)SvIV(ST(1))
;
#line 1944 "CArray.xs"
  double2 *array;
  AV *av;
#line 2984 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1947 "CArray.xs"
  if ((index < 0) || (index >= carray->len/2))
    croak (ErrMsg_index);
  array = (double2 *) carray->ptr;
  if (GIMME == G_ARRAY) {
    XST_mNV(0,array[index][0]);
    XST_mNV(1,array[index][1]);
    XSRETURN(2);
  } else {
    av = newAV();
    av_push(av, newSVnv( array[index][0] ));
    av_push(av, newSVnv( array[index][1] ));
    ST(0) = sv_2mortal(newRV((SV*) av));
    XSRETURN(1);
  }
#line 3009 "CArray.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDouble2Array_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble2Array_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CDoubleArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	AV *	value;
#line 1970 "CArray.xs"
  int i, len;
  double2 *array;
#line 3030 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;

        if (SvROK(ST(2))) value = (AV*)SvRV(ST(2));
	else croak("value is no ARRAYREF")
;
#line 1973 "CArray.xs"
  if ((index < 0) || (index >= carray->len/2))
    croak (ErrMsg_index);
  array = (double2 *) carray->ptr;
  len = min(av_len(value)+1,2);
  for (i=0; i<len; i++) {
    array[index][i] = SvNV(AvARRAY(value)[i]);
  }
#line 3052 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CDouble2Array_ToPar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble2Array_ToPar)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "carray, x=0, y=0");
    {
	Tie__CDoubleArray *	carray;
	Tie__CDoubleArray *	x = (items > 1) ? x = (Tie__CDoubleArray *) SvRV(ST(1)) : NULL;
	Tie__CDoubleArray *	y = (items > 2) ? y = (Tie__CDoubleArray *) SvRV(ST(2)) : NULL;
#line 1987 "CArray.xs"
  int i, len;
  double2 *array;
#line 3071 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 1990 "CArray.xs"
  len = carray->len / 2;
  array = (double2 *) carray->ptr;
  if (!x) {
    NEW_CARRAY(x,Tie__CDoubleArray,len,sizeof(NV));
  } else {
    CHECK_DERIVED_FROM(1,CDblNAME);
    MAYBE_GROW_CARRAY(x,Tie__CDoubleArray,len,sizeof(NV));
  }
  if (!y) {
    NEW_CARRAY(y,Tie__CDoubleArray,len,sizeof(NV));
  } else {
    CHECK_DERIVED_FROM(2,CDblNAME);
    MAYBE_GROW_CARRAY(y,Tie__CDoubleArray,len,sizeof(NV));
  }
  for (i=0; i < len; i++) {
    x->ptr[i] = array[i][0];
    y->ptr[i] = array[i][1];
  }
  RETVAL = newAV();
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CDblNAME, (void*)x));
  av_push(RETVAL, sv_setref_pv(sv_newmortal(), CDblNAME, (void*)y));
#line 3104 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDouble3Array_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble3Array_itemsize)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CDoubleArray *	carray;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 2022 "CArray.xs"
  RETVAL = sizeof(double3);
#line 3137 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDouble3Array_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble3Array_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CDoubleArray *	carray;
	int	index = (int)SvIV(ST(1))
;
#line 2033 "CArray.xs"
    double3 *array;
    AV *av;
#line 3158 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 2036 "CArray.xs"
    if ((index < 0) || (index >= carray->len/3))
      croak (ErrMsg_index);
    array = (double3 *) carray->ptr;
    if (GIMME == G_ARRAY) {
      EXTEND(sp,1);
      XST_mNV(0,array[index][0]);
      XST_mNV(1,array[index][1]);
      XST_mNV(2,array[index][2]);
      XSRETURN(3);
    } else {
      av = newAV();
      av_push(av, newSVnv( array[index][0] ));
      av_push(av, newSVnv( array[index][1] ));
      av_push(av, newSVnv( array[index][2] ));
      ST(0) = sv_2mortal(newRV((SV*) av));
      XSRETURN(1);
    }
#line 3186 "CArray.c"
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CDouble3Array_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble3Array_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CDoubleArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	AV *	value;
#line 2062 "CArray.xs"
  int i, len;
  double3 *array;
#line 3207 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;

        if (SvROK(ST(2))) value = (AV*)SvRV(ST(2));
	else croak("value is no ARRAYREF")
;
#line 2065 "CArray.xs"
  if ((index < 0) || (index >= carray->len/3))
    croak (ErrMsg_index);
  array = (double3 *) carray->ptr;
  len = min(av_len(value)+1,3);
  for (i=0; i < len; i++) {
    array[index][i] = SvNV(AvARRAY(value)[i]);
  }
#line 3229 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CDouble3Array_ToPar); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CDouble3Array_ToPar)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 4)
       croak_xs_usage(cv,  "carray, x=0, y=0, z=0");
    {
	Tie__CDoubleArray *	carray;
	Tie__CDoubleArray *	x = (items > 1) ? x = (Tie__CDoubleArray *) SvRV(ST(1)) : NULL;
	Tie__CDoubleArray *	y = (items > 2) ? y = (Tie__CDoubleArray *) SvRV(ST(2)) : NULL;
	Tie__CDoubleArray *	z = (items > 3) ? z = (Tie__CDoubleArray *) SvRV(ST(3)) : NULL;
#line 2080 "CArray.xs"
    int i, len;
    double3 *array;
#line 3249 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CDoubleArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CDoubleArray *, tmp);
	} else {
          croak("carray is not of type Tie::CDoubleArray");
	}
;
#line 2083 "CArray.xs"
    len = carray->len / 3;
    array = (double3 *) carray->ptr;
    if (!x) {
      NEW_CARRAY(x,Tie__CDoubleArray,len,sizeof(NV));
    } else {
      CHECK_DERIVED_FROM(1,CDblNAME);
      MAYBE_GROW_CARRAY(x,Tie__CDoubleArray,len,sizeof(NV));
    }
    if (!y) {
      NEW_CARRAY(y,Tie__CDoubleArray,len,sizeof(NV));
    } else {
      CHECK_DERIVED_FROM(1,CDblNAME);
      MAYBE_GROW_CARRAY(y,Tie__CDoubleArray,len,sizeof(NV));
    }
    if (!z) {
      NEW_CARRAY(z,Tie__CDoubleArray,len,sizeof(NV));
    } else {
      CHECK_DERIVED_FROM(1,CDblNAME);
      MAYBE_GROW_CARRAY(z,Tie__CDoubleArray,len,sizeof(NV));
    }
    for (i=0; i < len; i++) {
      x->ptr[i] = array[i][0];
      y->ptr[i] = array[i][1];
      z->ptr[i] = array[i][2];
    }
    RETVAL = newAV();
    av_push(RETVAL, sv_setref_pv(sv_newmortal(), CDblNAME, (void*)x));
    av_push(RETVAL, sv_setref_pv(sv_newmortal(), CDblNAME, (void*)y));
    av_push(RETVAL, sv_setref_pv(sv_newmortal(), CDblNAME, (void*)z));
#line 3290 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CStringArray_itemsize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_itemsize)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "carray, index=0");
    {
	Tie__CStringArray *	carray;
	int	index;
	int	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;

	if (items < 2)
	    index = 0;
	else {
	    index = (int)SvIV(ST(1))
;
	}
#line 2123 "CArray.xs"
  if (!index)
    RETVAL = sizeof(char *);
  else
    if ((index < 0) || (index >= carray->len))
      croak (ErrMsg_index);
    else
      RETVAL = strlen(carray->ptr[index]);
#line 3337 "CArray.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CStringArray_new); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_new)
{
    dVAR; dXSARGS;
    dXSI32;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 2138 "CArray.xs"
  int len;
  AV * av;
  char **array, *s;
  Tie__CStringArray *carray;
  int i, avlen;
  /* */
  if (items < 1 || items > 3)
    croak("Usage: new Tie::CStringArray(len, [AVPtr])");
  {
    /* need to check for ->new invocation, we'll have 3 args then */
    if ( g_classname = mysv_classname(ST(0)) ) {
        len = (int)SvIV(ST(1));
        av   = (items == 3) ? av = (AV*)SvRV(ST(2)) : NULL;
    } else {
        g_classname = CStrNAME;
        len = (int)SvIV(ST(0));
        av   = (items == 2) ? av = (AV*)SvRV(ST(1)) : NULL;
    }
    NEW_CARRAY(carray,Tie__CStringArray,len,sizeof(char *));
    memset (carray->ptr, 0, len + carray->freelen);
    if (av) {
      if (!strEQ(g_classname,CStrNAME))
        warn("can only initialize %s", CStrNAME);
      else
        myarray_init(g_classname, (Tie__CArray *)carray, av);
    }
    EXTEND(sp,1); /* one more */
    ST(0) = sv_newmortal();
    sv_setref_pv(ST(0), g_classname, (void*)carray);
    XSRETURN(1);
  }
#line 3386 "CArray.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Tie__CStringArray_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CStringArray *	carray;
#line 2175 "CArray.xs"
  char **array, *old;
  int len, i = 0;
#line 3404 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;
#line 2178 "CArray.xs"
#ifdef MYDEBUG_FREE
  DBG_PRINTF(("XSDbg: free (%p,->%p)\n",carray, carray->ptr));
#endif
  /* old = (char *) carray; */
  len   = carray->len;
  array = carray->ptr;
  if (array) {
      for (i=0; i<len; i++) {
        if (array[i]) safefree (array[i]);
        i++;
      }
      safefree (array);
  }
/*  SvROK_off(ST(0)); */
#ifdef MYDEBUG_FREE
  DBG_PRINTF((" unref (refSV: %d, RV: %p, IVRV: %p, refRV: %d)\n",
    SvREFCNT(ST(0)), SvRV(ST(0)), SvIV(SvRV(ST(0))), SvREFCNT(SvRV(ST(0))) ));
#endif
#line 3433 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CStringArray_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_delete)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CStringArray *	carray;
	int	index = (int)SvIV(ST(1))
;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;
#line 2202 "CArray.xs"
  /* deletes one item at index and shifts the rest */
  if ((index < 0) || (index >= carray->len))
    croak (ErrMsg_index);
  carray->freelen++;
  carray->len--;
  if (carray->ptr[index])
    safefree (carray->ptr[index]);
  memcpy (carray->ptr + index, carray->ptr + index+1,
          sizeof(char *) * (carray->len - index));
#line 3468 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CStringArray_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_get)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 2)
       croak_xs_usage(cv,  "carray, index");
    {
	Tie__CStringArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	char *	RETVAL;
	dXSTARG;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;
#line 2219 "CArray.xs"
  if ((index < 0) || (index >= carray->len))
    croak (ErrMsg_index);
  /* hmm, this fails the first time, but after nreverse it works okay... */
  RETVAL = strdup(carray->ptr[index]);
#line 3501 "CArray.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CStringArray_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_set)
{
    dVAR; dXSARGS;
    dXSI32;
    if (items != 3)
       croak_xs_usage(cv,  "carray, index, value");
    {
	Tie__CStringArray *	carray;
	int	index = (int)SvIV(ST(1))
;
	char *	value = (char *)SvPV_nolen(ST(2))
;
#line 2234 "CArray.xs"
    char *s;
#line 3523 "CArray.c"

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;
#line 2236 "CArray.xs"
    if ((index < 0) || (index >= carray->len))
        croak (ErrMsg_index);
    /* let the clib do that */
    s = (char *) saferealloc (carray->ptr[index], strlen(value)+1);
    carray->ptr[index] = s;
    strcpy (s, value);
#line 3540 "CArray.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Tie__CStringArray_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_copy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CStringArray *	carray;
#line 2247 "CArray.xs"
    SV * this = ST(0);
    int i, len;
    Tie__CStringArray * ncarray;
#line 3558 "CArray.c"
	Tie__CStringArray *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;
#line 2251 "CArray.xs"
    /* return a fresh copy
       this can only be "CStringArray" for now but maybe we derive from it later */
    len = carray->len;
    NEW_CARRAY(ncarray,Tie__CStringArray,len,sizeof(char *));
    for (i=0; i < len; i++) {
      ncarray->ptr[i] = strdup(carray->ptr[i]);
    }
    RETVAL = ncarray;
#line 3578 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv(RETVALSV, g_classname, (void*)RETVAL);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Tie__CStringArray_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Tie__CStringArray_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "carray");
    {
	Tie__CStringArray *	carray;
#line 2266 "CArray.xs"
    int i, len;
    char **array;
#line 3601 "CArray.c"
	AV *	RETVAL;

	g_classname = mysv_classname(ST(0));
        if (sv_derived_from(ST(0), "Tie::CStringArray")) {
          IV tmp = SvIV((SV*)SvRV(ST(0)));
	  carray = INT2PTR(Tie__CStringArray *, tmp);
	} else {
          croak("carray is not of type Tie::CStringArray");
	}
;
#line 2269 "CArray.xs"
    RETVAL = newAV();
    len = carray->len;
    array = carray->ptr;
    for (i=0; i<len; i++ ) {
        av_push(RETVAL, sv_2mortal( newSVpv( array[i],0 )));
    }
#line 3619 "CArray.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Tie__CArray); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Tie__CArray)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Tie::CArray::XS_rcs_string", XS_Tie__CArray_XS_rcs_string);
        newXS_deffile("Tie::CArray::XS_compile_date", XS_Tie__CArray_XS_compile_date);
        newXS_deffile("Tie::CArray::DESTROY", XS_Tie__CArray_DESTROY);
        cv = newXS_deffile("Tie::CArray::carray_FETCHSIZE", XS_Tie__CArray_len);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CArray::len", XS_Tie__CArray_len);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CArray::_freelen", XS_Tie__CArray__freelen);
        cv = newXS_deffile("Tie::CArray::carray_EXTEND", XS_Tie__CArray_grow);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CArray::carray_STORESIZE", XS_Tie__CArray_grow);
        XSANY.any_i32 = 2;
        cv = newXS_deffile("Tie::CArray::grow", XS_Tie__CArray_grow);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CArray::delete", XS_Tie__CArray_delete);
        newXS_deffile("Tie::CArray::copy", XS_Tie__CArray_copy);
        newXS_deffile("Tie::CArray::nreverse", XS_Tie__CArray_nreverse);
        newXS_deffile("Tie::CArray::CLEAR", XS_Tie__CArray_CLEAR);
        newXS_deffile("Tie::CArray::init", XS_Tie__CArray_init);
        newXS_deffile("Tie::CIntArray::itemsize", XS_Tie__CIntArray_itemsize);
        cv = newXS_deffile("Tie::CIntArray::int_TIEARRAY", XS_Tie__CIntArray_new);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CIntArray::new", XS_Tie__CIntArray_new);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CIntArray::get", XS_Tie__CIntArray_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CIntArray::int_FETCH", XS_Tie__CIntArray_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CIntArray::int_STORE", XS_Tie__CIntArray_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CIntArray::set", XS_Tie__CIntArray_set);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CIntArray::ToInt2", XS_Tie__CIntArray_ToInt2);
        newXS_deffile("Tie::CIntArray::ToInt3", XS_Tie__CIntArray_ToInt3);
        newXS_deffile("Tie::CIntArray::ToInt4", XS_Tie__CIntArray_ToInt4);
        newXS_deffile("Tie::CIntArray::list", XS_Tie__CIntArray_list);
        newXS_deffile("Tie::CInt2Array::itemsize", XS_Tie__CInt2Array_itemsize);
        cv = newXS_deffile("Tie::CInt2Array::get", XS_Tie__CInt2Array_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CInt2Array::int2_FETCH", XS_Tie__CInt2Array_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CInt2Array::int2_STORE", XS_Tie__CInt2Array_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CInt2Array::set", XS_Tie__CInt2Array_set);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CInt2Array::ToPar", XS_Tie__CInt2Array_ToPar);
        newXS_deffile("Tie::CInt3Array::itemsize", XS_Tie__CInt3Array_itemsize);
        cv = newXS_deffile("Tie::CInt3Array::get", XS_Tie__CInt3Array_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CInt3Array::int3_FETCH", XS_Tie__CInt3Array_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CInt3Array::int3_STORE", XS_Tie__CInt3Array_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CInt3Array::set", XS_Tie__CInt3Array_set);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CInt3Array::ToPar", XS_Tie__CInt3Array_ToPar);
        newXS_deffile("Tie::CInt4Array::itemsize", XS_Tie__CInt4Array_itemsize);
        cv = newXS_deffile("Tie::CInt4Array::get", XS_Tie__CInt4Array_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CInt4Array::int4_FETCH", XS_Tie__CInt4Array_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CInt4Array::int4_STORE", XS_Tie__CInt4Array_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CInt4Array::set", XS_Tie__CInt4Array_set);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CInt4Array::ToPar", XS_Tie__CInt4Array_ToPar);
        newXS_deffile("Tie::CDoubleArray::itemsize", XS_Tie__CDoubleArray_itemsize);
        cv = newXS_deffile("Tie::CDoubleArray::double_TIEARRAY", XS_Tie__CDoubleArray_new);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDoubleArray::new", XS_Tie__CDoubleArray_new);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CDoubleArray::double_FETCH", XS_Tie__CDoubleArray_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDoubleArray::get", XS_Tie__CDoubleArray_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CDoubleArray::double_STORE", XS_Tie__CDoubleArray_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDoubleArray::set", XS_Tie__CDoubleArray_set);
        XSANY.any_i32 = 0;
#if XSubPPtmpAAAA
        newXS_deffile("Tie::CDoubleArray::nreverse", XS_Tie__CDoubleArray_nreverse);
#endif
        newXS_deffile("Tie::CDoubleArray::ToDouble2", XS_Tie__CDoubleArray_ToDouble2);
        newXS_deffile("Tie::CDoubleArray::ToDouble3", XS_Tie__CDoubleArray_ToDouble3);
        newXS_deffile("Tie::CDoubleArray::list", XS_Tie__CDoubleArray_list);
        newXS_deffile("Tie::CDouble2Array::itemsize", XS_Tie__CDouble2Array_itemsize);
        cv = newXS_deffile("Tie::CDouble2Array::double2_FETCH", XS_Tie__CDouble2Array_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDouble2Array::get", XS_Tie__CDouble2Array_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CDouble2Array::double2_STORE", XS_Tie__CDouble2Array_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDouble2Array::set", XS_Tie__CDouble2Array_set);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CDouble2Array::ToPar", XS_Tie__CDouble2Array_ToPar);
        newXS_deffile("Tie::CDouble3Array::itemsize", XS_Tie__CDouble3Array_itemsize);
        cv = newXS_deffile("Tie::CDouble3Array::double3_FETCH", XS_Tie__CDouble3Array_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDouble3Array::get", XS_Tie__CDouble3Array_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CDouble3Array::double3_STORE", XS_Tie__CDouble3Array_set);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CDouble3Array::set", XS_Tie__CDouble3Array_set);
        XSANY.any_i32 = 0;
        newXS_deffile("Tie::CDouble3Array::ToPar", XS_Tie__CDouble3Array_ToPar);
        newXS_deffile("Tie::CStringArray::itemsize", XS_Tie__CStringArray_itemsize);
        cv = newXS_deffile("Tie::CStringArray::new", XS_Tie__CStringArray_new);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CStringArray::string_TIEARRAY", XS_Tie__CStringArray_new);
        XSANY.any_i32 = 1;
        newXS_deffile("Tie::CStringArray::DESTROY", XS_Tie__CStringArray_DESTROY);
        newXS_deffile("Tie::CStringArray::delete", XS_Tie__CStringArray_delete);
        cv = newXS_deffile("Tie::CStringArray::get", XS_Tie__CStringArray_get);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CStringArray::string_FETCH", XS_Tie__CStringArray_get);
        XSANY.any_i32 = 1;
        cv = newXS_deffile("Tie::CStringArray::set", XS_Tie__CStringArray_set);
        XSANY.any_i32 = 0;
        cv = newXS_deffile("Tie::CStringArray::string_STORE", XS_Tie__CStringArray_set);
        XSANY.any_i32 = 1;
        newXS_deffile("Tie::CStringArray::copy", XS_Tie__CStringArray_copy);
        newXS_deffile("Tie::CStringArray::list", XS_Tie__CStringArray_list);

    /* Initialisation Section */

#if XSubPPtmpAAAA
#endif
#line 2279 "CArray.xs"
{   /* These are the XS provided protected itemsizes.
       You might add more in perl per class (but not readonly).
       Todo: we'll get rid of this, stored in the struct as elsize */
#ifdef OLD
    mysv_ivcreate (sizeof(IV),     "Tie::CIntArray::itemsize",    SVf_READONLY);
    mysv_ivcreate (sizeof(int2),   "Tie::CInt2Array::itemsize",   SVf_READONLY);
    mysv_ivcreate (sizeof(int3),   "Tie::CInt3Array::itemsize",   SVf_READONLY);
    mysv_ivcreate (sizeof(int4),   "Tie::CInt4Array::itemsize",   SVf_READONLY);
    mysv_ivcreate (sizeof(NV),     "Tie::CDoubleArray::itemsize", SVf_READONLY);
    mysv_ivcreate (sizeof(double2),"Tie::CDouble2Array::itemsize",SVf_READONLY);
    mysv_ivcreate (sizeof(double3),"Tie::CDouble3Array::itemsize",SVf_READONLY);
    mysv_ivcreate (sizeof(char *), "Tie::CStringArray::itemsize", SVf_READONLY);
#endif /* OLD */
    /* we could also get the stashes now, but... */
}

#line 3802 "CArray.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

